package usgs.thorn;

import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.Writer;
import java.text.DecimalFormat;
import java.text.FieldPosition;
import java.text.SimpleDateFormat;
import java.util.GregorianCalendar;
import javax.swing.JOptionPane;

/**
*
*<pre>
* Simple Thornthwaite water balance
*
*</pre>
* @version  $Revision: 3303 $
* @author   $Author: $
*/

public class ThornReport {
    
    public ThornReport(ThornGUI gui, ThornData data) {
        GregorianCalendar gc = new GregorianCalendar();
        SimpleDateFormat date_format = new SimpleDateFormat("MMM-yyyy");
        DecimalFormat decimal_format = new DecimalFormat("0.0");
        decimal_format.setMaximumFractionDigits(1);
        decimal_format.setMinimumFractionDigits(1);
        
        double[] pe = data.getVariableValues("pet");
        double[] p = data.getVariableValues("precip");
        double[] pmpe = data.getVariableValues("precipPet");
        double[] stor = data.getVariableValues("soilMoist");
        double[] ae = data.getVariableValues("aet");
        double[] dff = data.getVariableValues("petAet");
        double[] snstor = data.getVariableValues("snow");
        double[] sur = data.getVariableValues("surplus");
        double[] ro = data.getVariableValues("runoff");
        
        int[] month = data.getMonth();
        int[] year = data.getYear();
        int width = 8;

        ReportFrame rf = new ReportFrame ();
        rf.setTopLevel(false);
        rf.setVisible(true);
        
/*
 **  Open the files.
 */
        try {
            Writer out = rf.getWriter();
                    
//                    tgd.getOutput_file()));
            
            
            out.write("                                           Soil                          Snow\n");
            out.write("   Date       PET        P       P-PET   Moisture     AET     PET-AET   Storage   Surplus   ROtotal\n");
            out.write("==================================================================================================\n");
            
            for (int i = 0; i < pe.length; i++) {
                gc.set(year[i], (month[i] - 1), 1);
                out.write(date_format.format(gc.getTime()) +
                            Format(pe[i], decimal_format, width) +
                            Format(p[i], decimal_format, width) +
                            Format(pmpe[i], decimal_format, width) +
                            Format(stor[i], decimal_format, width) +
                            Format(ae[i], decimal_format, width) +
                            Format(dff[i], decimal_format, width) +
                            Format(snstor[i], decimal_format, width) +
                            Format(sur[i], decimal_format, width) +
                            Format(ro[i], decimal_format, width) + "\n");
            }
            out.flush();
            out.close();
            
        } catch (Exception ioe) {
            return;
        }
    }
    
    private static FieldPosition field_pos = new FieldPosition(DecimalFormat.INTEGER_FIELD);
    
    private static StringBuffer Format (double val, DecimalFormat df, int width) {
        StringBuffer foo = df.format (val, new StringBuffer (0), field_pos);
        for (int k = 0; k < (width - field_pos.getEndIndex()); k++) {
            foo.insert (0, ' ');
        }
        return foo;
    }
}
